package aux

import (
	"encoding/base64"
	"fmt"
	"github.com/rs/zerolog"
	//"github.com/rs/zerolog/log"
	"bladerunner/arrange"
	"os"
	"time"
)

var (
	logFile *os.File
	err     error
	banner  string = "ICAgX19fXyAgX18gICAgIF9fXyAgX19fX18gX19fX18gCiAgIHx8PSkgIHx8ICAgIHx8PXx8IHx8ICApIHx8PT0gIFIKICAgfHxfKSkgfHxfX3wgfHwgfHwgfHxfLy8gfHxfX18gRgpfX19fXyBfXyBfXyBfXyAgX18gX18gIF9fIF9fX19fIF9fX19fIAp8fF8vLyB8fCB8fCB8fFxcfHwgfHxcXHx8IHx8PT0gIHx8Xy8vIAp8fCBcXCBcXF8vLyB8fCBcfHwgfHwgXHx8IHx8X19fIHx8IFxcIAo="
)

func Banner() {
	dec, _ := base64.StdEncoding.DecodeString(banner)
	fmt.Println(string(dec))
}

func LogInit() zerolog.Logger {
	if err := os.MkdirAll(arrange.LogDir, 0755); err != nil {
		panic("cannot create log directory: " + arrange.LogDir + "(" + err.Error() + ")")
	}
	if logFile, err = os.OpenFile(arrange.LogDir+time.Now().Format(time.RFC3339)+".log", os.O_RDWR|os.O_CREATE|os.O_APPEND, 0666); err != nil {
		panic("cannot create log file: " + err.Error())
	}
	multi := zerolog.MultiLevelWriter(zerolog.ConsoleWriter{Out: os.Stderr}, logFile)
	return zerolog.New(multi).With().Timestamp().Logger()
}
